"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("react"),t=require("styled-components");function n(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}function o(e){if(e&&e.__esModule)return e;var t=Object.create(null);return e&&Object.keys(e).forEach((function(n){if("default"!==n){var o=Object.getOwnPropertyDescriptor(e,n);Object.defineProperty(t,n,o.get?o:{enumerable:!0,get:function(){return e[n]}})}})),t.default=e,Object.freeze(t)}var a,l=o(e),r=n(e),i=n(t);function s(e,t){return e[t]}function d(e,t){return t.split(".").reduce(((e,t)=>{const n=t.match(/[^\]\\[.]+/g);if(n&&n.length>1)for(let t=0;t<n.length;t++)return e[n[t]][n[t+1]];return e[t]}),e)}function c(e=[],t,n=0){return[...e.slice(0,n),t,...e.slice(n)]}function g(e=[],t,n="id"){const o=e.slice(),a=s(t,n);return a?o.splice(o.findIndex((e=>s(e,n)===a)),1):o.splice(o.findIndex((e=>e===t)),1),o}function u(e){return e.map(((e,t)=>{const n=Object.assign(Object.assign({},e),{sortable:e.sortable||!!e.sortFunction||void 0});return e.id||(n.id=t+1),n}))}function p(e,t){return Math.ceil(e/t)}function f(e,t){return Math.min(e,t)}!function(e){e.ASC="asc",e.DESC="desc"}(a||(a={}));const b=()=>null;function m(e,t=[],n=[]){let o={},a=[...n];return t.length&&t.forEach((t=>{if(!t.when||"function"!=typeof t.when)throw new Error('"when" must be defined in the conditional style object and must be function');t.when(e)&&(o=t.style||{},t.classNames&&(a=[...a,...t.classNames]),"function"==typeof t.style&&(o=t.style(e)||{}))})),{style:o,classNames:a.join(" ")}}function h(e,t=[],n="id"){const o=s(e,n);return o?t.some((e=>s(e,n)===o)):t.some((t=>t===e))}function w(e,t){return t?e.findIndex((e=>x(e.id,t))):-1}function x(e,t){return e==t}function C(e,t){const n=!e.toggleOnSelectedRowsChange;switch(t.type){case"SELECT_ALL_ROWS":{const{keyField:n,rows:o,rowCount:a,mergeSelections:l}=t,r=!e.allSelected,i=!e.toggleOnSelectedRowsChange;if(l){const t=r?[...e.selectedRows,...o.filter((t=>!h(t,e.selectedRows,n)))]:e.selectedRows.filter((e=>!h(e,o,n)));return Object.assign(Object.assign({},e),{allSelected:r,selectedCount:t.length,selectedRows:t,toggleOnSelectedRowsChange:i})}return Object.assign(Object.assign({},e),{allSelected:r,selectedCount:r?a:0,selectedRows:r?o:[],toggleOnSelectedRowsChange:i})}case"SELECT_SINGLE_ROW":{const{keyField:o,row:a,isSelected:l,rowCount:r,singleSelect:i}=t;return i?l?Object.assign(Object.assign({},e),{selectedCount:0,allSelected:!1,selectedRows:[],toggleOnSelectedRowsChange:n}):Object.assign(Object.assign({},e),{selectedCount:1,allSelected:!1,selectedRows:[a],toggleOnSelectedRowsChange:n}):l?Object.assign(Object.assign({},e),{selectedCount:e.selectedRows.length>0?e.selectedRows.length-1:0,allSelected:!1,selectedRows:g(e.selectedRows,a,o),toggleOnSelectedRowsChange:n}):Object.assign(Object.assign({},e),{selectedCount:e.selectedRows.length+1,allSelected:e.selectedRows.length+1===r,selectedRows:c(e.selectedRows,a),toggleOnSelectedRowsChange:n})}case"SELECT_MULTIPLE_ROWS":{const{keyField:o,selectedRows:a,totalRows:l,mergeSelections:r}=t;if(r){const t=[...e.selectedRows,...a.filter((t=>!h(t,e.selectedRows,o)))];return Object.assign(Object.assign({},e),{selectedCount:t.length,allSelected:!1,selectedRows:t,toggleOnSelectedRowsChange:n})}return Object.assign(Object.assign({},e),{selectedCount:a.length,allSelected:a.length===l,selectedRows:a,toggleOnSelectedRowsChange:n})}case"CLEAR_SELECTED_ROWS":{const{selectedRowsFlag:n}=t;return Object.assign(Object.assign({},e),{allSelected:!1,selectedCount:0,selectedRows:[],selectedRowsFlag:n})}case"SORT_CHANGE":{const{sortDirection:o,selectedColumn:a,clearSelectedOnSort:l}=t;return Object.assign(Object.assign(Object.assign({},e),{selectedColumn:a,sortDirection:o,currentPage:1}),l&&{allSelected:!1,selectedCount:0,selectedRows:[],toggleOnSelectedRowsChange:n})}case"CHANGE_PAGE":{const{page:o,paginationServer:a,visibleOnly:l,persistSelectedOnPageChange:r}=t,i=a&&r,s=a&&!r||l;return Object.assign(Object.assign(Object.assign(Object.assign({},e),{currentPage:o}),i&&{allSelected:!1}),s&&{allSelected:!1,selectedCount:0,selectedRows:[],toggleOnSelectedRowsChange:n})}case"CHANGE_ROWS_PER_PAGE":{const{rowsPerPage:n,page:o}=t;return Object.assign(Object.assign({},e),{currentPage:o,rowsPerPage:n})}}}const v=t.css`
	pointer-events: none;
	opacity: 0.4;
`,y=i.default.div`
	position: relative;
	box-sizing: border-box;
	display: flex;
	flex-direction: column;
	width: 100%;
	height: 100%;
	max-width: 100%;
	${({disabled:e})=>e&&v};
	${({theme:e})=>e.table.style};
`,R=t.css`
	position: sticky;
	position: -webkit-sticky; /* Safari */
	top: 0;
	z-index: 2;
`,S=i.default.div`
	display: flex;
	width: 100%;
	${({fixedHeader:e})=>e&&R};
	${({theme:e})=>e.head.style};
`,E=i.default.div`
	display: flex;
	align-items: stretch;
	width: 100%;
	${({theme:e})=>e.headRow.style};
	${({dense:e,theme:t})=>e&&t.headRow.denseStyle};
`,O=(e,...n)=>t.css`
		@media screen and (max-width: ${599}px) {
			${t.css(e,...n)}
		}
	`,k=(e,...n)=>t.css`
		@media screen and (max-width: ${959}px) {
			${t.css(e,...n)}
		}
	`,P=(e,...n)=>t.css`
		@media screen and (max-width: ${1280}px) {
			${t.css(e,...n)}
		}
	`,D=e=>(n,...o)=>t.css`
				@media screen and (max-width: ${e}px) {
					${t.css(n,...o)}
				}
			`,$=(e,...n)=>t.css`
    @media screen and (min-width: ${599}px) {
      ${t.css(e,...n)}
    }
  `,H=(e,...n)=>t.css`
    @media screen and (min-width: ${959}px) {
      ${t.css(e,...n)}
    }
  `,j=(e,...n)=>t.css`
    @media screen and (min-width: ${1280}px) {
      ${t.css(e,...n)}
    }
  `,F=e=>(n,...o)=>t.css`
        @media screen and (min-width: ${e}px) {
          ${t.css(n,...o)}
        }
      `,I=i.default.div`
	position: relative;
	display: flex;
	align-items: center;
	box-sizing: border-box;
	line-height: normal;
	${({theme:e,headCell:t})=>e[t?"headCells":"cells"].style};
	${({noPadding:e})=>e&&"padding: 0"};
`,T=e=>`\n    position: sticky;\n    background-color: #fff;\n    left: ${e};\n    z-index: 1;\n  `,M=i.default(I).attrs((e=>({style:{maxWidth:e.width?e.width:e.maxWidth?e.maxWidth:"100%",minWidth:e.width?e.width:e.minWidth?e.minWidth:"100px"}})))`
	flex-grow: ${({button:e,grow:t})=>0===t||e?0:t||1};
	flex-shrink: 0;
	flex-basis: 0;
	${({right:e})=>e&&"justify-content: flex-end"};
	${({button:e,center:t})=>(t||e)&&"justify-content: center"};
	${({compact:e,button:t})=>(e||t)&&"padding: 0"};

	/* handle hiding cells */
	${({hide:e})=>e&&"sm"===e&&O`
    display: none;
  `};
	${({hide:e})=>e&&"md"===e&&k`
    display: none;
  `};
	${({hide:e})=>e&&"lg"===e&&P`
    display: none;
  `};
	${({hide:e})=>e&&Number.isInteger(e)&&D(e)`
    display: none;
  `};
  /* handle freezing cells */
	${({freeze:e,leftOffset:t})=>e&&"sm"===e&&t&&$`
    ${T(t)}
  `};
	${({freeze:e,leftOffset:t})=>e&&"md"===e&&t&&H`
    ${T(t)}
  `};
	${({freeze:e,leftOffset:t})=>e&&"lg"===e&&t&&j`
    ${T(t)}
  `};
	${({freeze:e,leftOffset:t})=>e&&t&&Number.isInteger(e)&&F(e)`
		${T(t)}
	`};
	${({freeze:e,leftOffset:n})=>!0===e&&n&&t.css`
		${T(n)}
  `};
`,L=t.css`
	div:first-child {
		white-space: ${({wrapCell:e})=>e?"normal":"nowrap"};
		overflow: ${({allowOverflow:e})=>e?"visible":"hidden"};
		text-overflow: ellipsis;
	}
`,A=i.default(M).attrs((e=>({style:e.style})))`
	${({renderAsCell:e})=>!e&&L};
	${({theme:e,isDragging:t})=>t&&e.cells.draggingStyle};
	${({cellStyle:e})=>e};
`;var z=l.memo((function({id:e,column:t,row:n,rowIndex:o,dataTag:a,isDragging:r,onDragStart:i,onDragOver:s,onDragEnd:c,onDragEnter:g,onDragLeave:u}){const{style:p,classNames:f}=m(n,t.conditionalCellStyles,["rdt_TableCell"]);return l.createElement(A,{id:e,"data-column-id":t.id,role:"cell",className:f,"data-tag":a,cellStyle:t.style,renderAsCell:!!t.cell,allowOverflow:t.allowOverflow,button:t.button,center:t.center,compact:t.compact,grow:t.grow,hide:t.hide,freeze:t.freeze,leftOffset:t.leftOffset,maxWidth:t.maxWidth,minWidth:t.minWidth,right:t.right,width:t.width,wrapCell:t.wrap,style:p,isDragging:r,onDragStart:i,onDragOver:s,onDragEnd:c,onDragEnter:g,onDragLeave:u},!t.cell&&l.createElement("div",{"data-tag":a},function(e,t,n,o){if(!t)return null;if("string"!=typeof t&&"function"!=typeof t)throw new Error("selector must be a . delimited string eg (my.property) or function (e.g. row => row.field");return n&&"function"==typeof n?n(e,o):t&&"function"==typeof t?t(e,o):d(e,t)}(n,t.selector,t.format,o)),t.cell&&t.cell(n,o,t,e))}));var _=l.memo((function({name:e,component:t="input",componentOptions:n={style:{}},indeterminate:o=!1,checked:a=!1,disabled:r=!1,onClick:i=b}){const s=t,d="input"!==s?n.style:(e=>Object.assign(Object.assign({fontSize:"18px"},!e&&{cursor:"pointer"}),{padding:0,marginTop:"1px",verticalAlign:"middle",position:"relative"}))(r),c=l.useMemo((()=>function(e,...t){let n;return Object.keys(e).map((t=>e[t])).forEach(((o,a)=>{const l=e;"function"==typeof o&&(n=Object.assign(Object.assign({},l),{[Object.keys(e)[a]]:o(...t)}))})),n||e}(n,o)),[n,o]);return l.createElement(s,Object.assign({type:"checkbox",ref:e=>{e&&(e.indeterminate=o)},style:d,onClick:r?b:i,name:e,"aria-label":e,checked:a,disabled:r},c,{onChange:b}))}));const N=i.default(I)`
	flex: 0 0 48px;
	min-width: 48px;
	justify-content: center;
	align-items: center;
	user-select: none;
	white-space: nowrap;
`;function W({name:e,keyField:t,row:n,rowCount:o,selected:a,selectableRowsComponent:r,selectableRowsComponentProps:i,selectableRowsSingle:s,selectableRowDisabled:d,onSelectedRow:c}){const g=!(!d||!d(n));return l.createElement(N,{onClick:e=>e.stopPropagation(),className:"rdt_TableCell",noPadding:!0},l.createElement(_,{name:e,component:r,componentOptions:i,checked:a,"aria-checked":a,onClick:()=>{c({type:"SELECT_SINGLE_ROW",row:n,isSelected:a,keyField:t,rowCount:o,singleSelect:s})},disabled:g}))}const B=i.default.button`
	display: inline-flex;
	align-items: center;
	user-select: none;
	white-space: nowrap;
	border: none;
	background-color: transparent;
	${({theme:e})=>e.expanderButton.style};
`;function G({disabled:e=!1,expanded:t=!1,expandableIcon:n,id:o,row:a,onToggled:r}){const i=t?n.expanded:n.collapsed;return l.createElement(B,{"aria-disabled":e,onClick:()=>r&&r(a),"data-testid":`expander-button-${o}`,disabled:e,"aria-label":t?"Collapse Row":"Expand Row",role:"button",type:"button"},i)}const V=i.default(I)`
	white-space: nowrap;
	font-weight: 400;
	min-width: 48px;
	${({theme:e})=>e.expanderCell.style};
`;function U({row:e,expanded:t=!1,expandableIcon:n,id:o,onToggled:a,disabled:r=!1}){return l.createElement(V,{onClick:e=>e.stopPropagation(),noPadding:!0},l.createElement(G,{id:o,row:e,expanded:t,expandableIcon:n,disabled:r,onToggled:a}))}const q=i.default.div`
	width: 100%;
	box-sizing: border-box;
	${({theme:e})=>e.expanderRow.style};
	${({extendedRowStyle:e})=>e};
`;var Y=l.memo((function({data:e,ExpanderComponent:t,expanderComponentProps:n,extendedRowStyle:o,extendedClassNames:a}){const r=["rdt_ExpanderRow",...a.split(" ").filter((e=>"rdt_TableRow"!==e))].join(" ");return l.createElement(q,{className:r,extendedRowStyle:o},l.createElement(t,Object.assign({data:e},n)))}));var K,X,J;exports.Direction=void 0,(K=exports.Direction||(exports.Direction={})).LTR="ltr",K.RTL="rtl",K.AUTO="auto",exports.Alignment=void 0,(X=exports.Alignment||(exports.Alignment={})).LEFT="left",X.RIGHT="right",X.CENTER="center",exports.Media=void 0,(J=exports.Media||(exports.Media={})).SM="sm",J.MD="md",J.LG="lg";const Q=t.css`
	&:hover {
		${({highlightOnHover:e,theme:t})=>e&&t.rows.highlightOnHoverStyle};
	}
`,Z=t.css`
	&:hover {
		cursor: pointer;
	}
`,ee=i.default.div.attrs((e=>({style:e.style})))`
	display: flex;
	align-items: stretch;
	align-content: stretch;
	width: 100%;
	box-sizing: border-box;
	${({theme:e})=>e.rows.style};
	${({dense:e,theme:t})=>e&&t.rows.denseStyle};
	${({striped:e,theme:t})=>e&&t.rows.stripedStyle};
	${({highlightOnHover:e})=>e&&Q};
	${({pointerOnHover:e})=>e&&Z};
	${({selected:e,theme:t})=>e&&t.rows.selectedHighlightStyle};
`;function te({columns:e=[],conditionalRowStyles:t=[],defaultExpanded:n=!1,defaultExpanderDisabled:o=!1,dense:a=!1,expandableIcon:r,expandableRows:i=!1,expandableRowsComponent:d,expandableRowsComponentProps:c,expandableRowsHideExpander:g,expandOnRowClicked:u=!1,expandOnRowDoubleClicked:p=!1,highlightOnHover:f=!1,id:h,expandableInheritConditionalStyles:w,keyField:C,onRowClicked:v=b,onRowDoubleClicked:y=b,onRowMouseEnter:R=b,onRowMouseLeave:S=b,onRowExpandToggled:E=b,onSelectedRow:O=b,pointerOnHover:k=!1,row:P,rowCount:D,rowIndex:$,selectableRowDisabled:H=null,selectableRows:j=!1,selectableRowsComponent:F,selectableRowsComponentProps:I,selectableRowsHighlight:T=!1,selectableRowsSingle:M=!1,selected:L,striped:A=!1,draggingColumnId:_,onDragStart:N,onDragOver:B,onDragEnd:G,onDragEnter:V,onDragLeave:q}){const[K,X]=l.useState(n);l.useEffect((()=>{X(n)}),[n]);const J=l.useCallback((()=>{X(!K),E(!K,P)}),[K,E,P]),Q=k||i&&(u||p),Z=l.useCallback((e=>{e.target&&"allowRowEvents"===e.target.getAttribute("data-tag")&&(v(P,e),!o&&i&&u&&J())}),[o,u,i,J,v,P]),te=l.useCallback((e=>{e.target&&"allowRowEvents"===e.target.getAttribute("data-tag")&&(y(P,e),!o&&i&&p&&J())}),[o,p,i,J,y,P]),ne=l.useCallback((e=>{R(P,e)}),[R,P]),oe=l.useCallback((e=>{S(P,e)}),[S,P]),ae=s(P,C),{style:le,classNames:re}=m(P,t,["rdt_TableRow"]),ie=T&&L,se=w?le:{},de=A&&$%2==0;return l.createElement(l.Fragment,null,l.createElement(ee,{id:`row-${h}`,role:"row",striped:de,highlightOnHover:f,pointerOnHover:!o&&Q,dense:a,onClick:Z,onDoubleClick:te,onMouseEnter:ne,onMouseLeave:oe,className:re,selected:ie,style:le},j&&l.createElement(W,{name:`select-row-${ae}`,keyField:C,row:P,rowCount:D,selected:L,selectableRowsComponent:F,selectableRowsComponentProps:I,selectableRowDisabled:H,selectableRowsSingle:M,onSelectedRow:O}),i&&!g&&l.createElement(U,{id:ae,expandableIcon:r,expanded:K,row:P,onToggled:J,disabled:o}),e.map((e=>e.omit?null:l.createElement(z,{id:`cell-${e.id}-${ae}`,key:`cell-${e.id}-${ae}`,dataTag:e.ignoreRowClick||e.button?null:"allowRowEvents",column:e,row:P,rowIndex:$,isDragging:x(_,e.id),onDragStart:N,onDragOver:B,onDragEnd:G,onDragEnter:V,onDragLeave:q})))),i&&K&&l.createElement(Y,{key:`expander-${ae}`,data:P,extendedRowStyle:se,extendedClassNames:re,ExpanderComponent:d,expanderComponentProps:c}))}const ne=i.default.span`
	padding: 2px;
	color: inherit;
	flex-grow: 0;
	flex-shrink: 0;
	${({sortActive:e})=>e?"opacity: 1":"opacity: 0"};
	${({sortDirection:e})=>"desc"===e&&"transform: rotate(180deg)"};
`,oe=({sortActive:e,sortDirection:t})=>r.default.createElement(ne,{sortActive:e,sortDirection:t},"▲"),ae=i.default(M)`
	${({button:e})=>e&&"text-align: center"};
	${({theme:e,isDragging:t})=>t&&e.headCells.draggingStyle};
`,le=t.css`
	cursor: pointer;
	span.__rdt_custom_sort_icon__ {
		i,
		svg {
			transform: 'translate3d(0, 0, 0)';
			${({sortActive:e})=>e?"opacity: 1":"opacity: 0"};
			color: inherit;
			font-size: 18px;
			height: 18px;
			width: 18px;
			backface-visibility: hidden;
			transform-style: preserve-3d;
			transition-duration: 95ms;
			transition-property: transform;
		}

		&.asc i,
		&.asc svg {
			transform: rotate(180deg);
		}
	}

	${({sortActive:e})=>!e&&t.css`
			&:hover,
			&:focus {
				opacity: 0.7;

				span,
				span.__rdt_custom_sort_icon__ * {
					opacity: 0.7;
				}
			}
		`};
`,re=i.default.div`
	display: inline-flex;
	align-items: center;
	justify-content: inherit;
	height: 100%;
	width: 100%;
	outline: none;
	user-select: none;
	overflow: hidden;
	${({disabled:e})=>!e&&le};
`,ie=i.default.div`
	overflow: hidden;
	white-space: nowrap;
	text-overflow: ellipsis;
`,se=i.default.div`
	display: block;
	position: absolute;
	cursor: col-resize;
	width: 7px;
	min-height: 52px;
	right 0;
	top: 0;
	z-index: 2;
	border-right: 2px solid transparent;
	&:hover {
		border-color: #ccc;
	}
	&.active {
		border-color: #add8e6;
	}
`;var de=l.memo((function({column:e,disabled:t,draggingColumnId:n,resizingColumnId:o,selectedColumn:r={},sortDirection:i,sortIcon:s,sortServer:d,pagination:c,paginationServer:g,persistSelectedOnSort:u,selectableRowsVisibleOnly:p,onSort:f,onDragStart:b,onDragOver:m,onDragEnd:h,onDragEnter:w,onDragLeave:C,handleResizeStart:v,setColumnOffset:y}){const[R,S]=l.useState(!1),E=l.useRef(null);if(l.useEffect((()=>{E.current&&S(E.current.scrollWidth>E.current.clientWidth)}),[R]),l.useEffect((()=>{var t;if(E.current&&e.freeze&&e.id){const n=(null===(t=E.current.parentNode)||void 0===t?void 0:t.parentNode).offsetLeft;console.log(n,e.id),y(n,e.id)}}),[n,o]),e.omit)return null;const O=()=>{if(!e.sortable&&!e.selector)return;let t=i;x(r.id,e.id)&&(t=i===a.ASC?a.DESC:a.ASC),f({type:"SORT_CHANGE",sortDirection:t,selectedColumn:e,clearSelectedOnSort:c&&g&&!u||d||p})},k=e=>l.createElement(oe,{sortActive:e,sortDirection:i}),P=()=>l.createElement("span",{className:[i,"__rdt_custom_sort_icon__"].join(" ")},s),D=!(!e.sortable||!x(r.id,e.id)),$=!e.sortable||t,H=e.sortable&&!s&&!e.right,j=e.sortable&&!s&&e.right,F=e.sortable&&s&&!e.right,I=e.sortable&&s&&e.right;return l.createElement(ae,{"data-column-id":e.id,className:"rdt_TableCol",headCell:!0,allowOverflow:e.allowOverflow,button:e.button,compact:e.compact,grow:e.grow,hide:e.hide,freeze:e.freeze,leftOffset:e.leftOffset,maxWidth:e.maxWidth,minWidth:e.minWidth,right:e.right,center:e.center,width:e.width,draggable:e.reorder&&""===o,isDragging:x(e.id,n),onDragStart:b,onDragOver:m,onDragEnd:h,onDragEnter:w,onDragLeave:C},e.name&&l.createElement(re,{"data-column-id":e.id,"data-sort-id":e.id,role:"columnheader",tabIndex:0,className:"rdt_TableCol_Sortable",onClick:$?void 0:O,onKeyPress:$?void 0:e=>{"Enter"===e.key&&O()},sortActive:!$&&D,disabled:$},!$&&I&&P(),!$&&j&&k(D),"string"==typeof e.name?l.createElement(ie,{title:R?e.name:void 0,ref:E,"data-column-id":e.id},e.name):e.name,!$&&F&&P(),!$&&H&&k(D)),e.resize&&l.createElement(se,{className:"rdt_ResizeHandle "+(x(e.id,o)?"active":""),onPointerDown:v}))}));const ce=i.default(I)`
	flex: 0 0 48px;
	justify-content: center;
	align-items: center;
	user-select: none;
	white-space: nowrap;
	font-size: unset;
`;function ge({headCell:e=!0,rowData:t,keyField:n,allSelected:o,mergeSelections:a,selectedRows:r,selectableRowsComponent:i,selectableRowsComponentProps:s,selectableRowDisabled:d,onSelectAllRows:c}){const g=r.length>0&&!o,u=d?t.filter((e=>!d(e))):t,p=0===u.length,f=Math.min(t.length,u.length);return l.createElement(ce,{className:"rdt_TableCol",headCell:e,noPadding:!0},l.createElement(_,{name:"select-all-rows",component:i,componentOptions:s,onClick:()=>{c({type:"SELECT_ALL_ROWS",rows:u,rowCount:f,mergeSelections:a,keyField:n})},checked:o,indeterminate:g,disabled:p}))}function ue(e=exports.Direction.AUTO){const t="object"==typeof window,[n,o]=l.useState(!1);return l.useEffect((()=>{if(t)if("auto"!==e)o("rtl"===e);else{const e=!(!window.document||!window.document.createElement),t=document.getElementsByTagName("BODY")[0],n=document.getElementsByTagName("HTML")[0],a="rtl"===t.dir||"rtl"===n.dir;o(e&&a)}}),[e,t]),n}const pe=i.default.div`
	display: flex;
	align-items: center;
	flex: 1 0 auto;
	height: 100%;
	color: ${({theme:e})=>e.contextMenu.fontColor};
	font-size: ${({theme:e})=>e.contextMenu.fontSize};
	font-weight: 400;
`,fe=i.default.div`
	display: flex;
	align-items: center;
	justify-content: flex-end;
	flex-wrap: wrap;
`,be=i.default.div`
	position: absolute;
	top: 0;
	left: 0;
	width: 100%;
	height: 100%;
	box-sizing: inherit;
	z-index: 2;
	align-items: center;
	justify-content: space-between;
	display: flex;
	${({rtl:e})=>e&&"direction: rtl"};
	${({theme:e})=>e.contextMenu.style};
	${({theme:e,visible:t})=>t&&e.contextMenu.activeStyle};
`;function me({contextMessage:e,contextActions:t,contextComponent:n,selectedCount:o,direction:a}){const r=ue(a),i=o>0;return n?l.createElement(be,{visible:i},l.cloneElement(n,{selectedCount:o})):l.createElement(be,{visible:i,rtl:r},l.createElement(pe,null,((e,t,n)=>{if(0===t)return null;const o=1===t?e.singular:e.plural;return n?`${t} ${e.message||""} ${o}`:`${t} ${o} ${e.message||""}`})(e,o,r)),l.createElement(fe,null,t))}const he=i.default.div`
	position: relative;
	box-sizing: border-box;
	overflow: hidden;
	display: flex;
	flex: 1 1 auto;
	align-items: center;
	justify-content: space-between;
	width: 100%;
	flex-wrap: wrap;
	${({theme:e})=>e.header.style}
`,we=i.default.div`
	flex: 1 0 auto;
	color: ${({theme:e})=>e.header.fontColor};
	font-size: ${({theme:e})=>e.header.fontSize};
	font-weight: 400;
`,xe=i.default.div`
	flex: 1 0 auto;
	display: flex;
	align-items: center;
	justify-content: flex-end;

	> * {
		margin-left: 5px;
	}
`,Ce=({title:e,actions:t=null,contextMessage:n,contextActions:o,contextComponent:a,selectedCount:r,direction:i,showMenu:s=!0})=>l.createElement(he,{className:"rdt_TableHeader",role:"heading","aria-level":1},l.createElement(we,null,e),t&&l.createElement(xe,null,t),s&&l.createElement(me,{contextMessage:n,contextActions:o,contextComponent:a,direction:i,selectedCount:r}))
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */;function ve(e,t){var n={};for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&t.indexOf(o)<0&&(n[o]=e[o]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var a=0;for(o=Object.getOwnPropertySymbols(e);a<o.length;a++)t.indexOf(o[a])<0&&Object.prototype.propertyIsEnumerable.call(e,o[a])&&(n[o[a]]=e[o[a]])}return n}const ye={left:"flex-start",right:"flex-end",center:"center"},Re=i.default.header`
	position: relative;
	display: flex;
	flex: 1 1 auto;
	box-sizing: border-box;
	align-items: center;
	padding: 4px 16px 4px 24px;
	width: 100%;
	justify-content: ${({align:e})=>ye[e]};
	flex-wrap: ${({wrapContent:e})=>e?"wrap":"nowrap"};
	${({theme:e})=>e.subHeader.style}
`,Se=e=>{var{align:t="right",wrapContent:n=!0}=e,o=ve(e,["align","wrapContent"]);return l.createElement(Re,Object.assign({align:t,wrapContent:n},o))},Ee=i.default.div`
	display: flex;
	flex-direction: column;
`,Oe=i.default.div`
	position: relative;
	width: 100%;
	border-radius: inherit;
	${({responsive:e,fixedHeader:n})=>e&&t.css`
			overflow-x: auto;

			// hidden prevents vertical scrolling in firefox when fixedHeader is disabled
			overflow-y: ${n?"auto":"hidden"};
			min-height: 0;
		`};

	${({fixedHeader:e=!1,fixedHeaderScrollHeight:n="100vh"})=>e&&t.css`
			max-height: ${n};
			-webkit-overflow-scrolling: touch;
		`};

	${({theme:e})=>e.responsiveWrapper.style};
`,ke=i.default.div`
	position: relative;
	box-sizing: border-box;
	width: 100%;
	height: 100%;
	${e=>e.theme.progress.style};
`,Pe=i.default.div`
	position: relative;
	width: 100%;
	${({theme:e})=>e.tableWrapper.style};
`,De=i.default(I)`
	white-space: nowrap;
	${({theme:e})=>e.expanderCell.style};
`,$e=i.default.div`
	box-sizing: border-box;
	width: 100%;
	height: 100%;
	${({theme:e})=>e.noData.style};
`,He=()=>r.default.createElement("svg",{xmlns:"http://www.w3.org/2000/svg",width:"24",height:"24",viewBox:"0 0 24 24"},r.default.createElement("path",{d:"M7 10l5 5 5-5z"}),r.default.createElement("path",{d:"M0 0h24v24H0z",fill:"none"})),je=i.default.select`
	cursor: pointer;
	height: 24px;
	max-width: 100%;
	user-select: none;
	padding-left: 8px;
	padding-right: 24px;
	box-sizing: content-box;
	font-size: inherit;
	color: inherit;
	border: none;
	background-color: transparent;
	appearance: none;
	direction: ltr;
	flex-shrink: 0;

	&::-ms-expand {
		display: none;
	}

	&:disabled::-ms-expand {
		background: #f60;
	}

	option {
		color: initial;
	}
`,Fe=i.default.div`
	position: relative;
	flex-shrink: 0;
	font-size: inherit;
	color: inherit;
	margin-top: 1px;

	svg {
		top: 0;
		right: 0;
		color: inherit;
		position: absolute;
		fill: currentColor;
		width: 24px;
		height: 24px;
		display: inline-block;
		user-select: none;
		pointer-events: none;
	}
`,Ie=e=>{var{defaultValue:t,onChange:n}=e,o=ve(e,["defaultValue","onChange"]);return l.createElement(Fe,null,l.createElement(je,Object.assign({onChange:n,defaultValue:t},o)),l.createElement(He,null))},Te={columns:[],data:[],title:"",keyField:"id",selectableRows:!1,selectableRowsHighlight:!1,selectableRowsNoSelectAll:!1,selectableRowSelected:null,selectableRowDisabled:null,selectableRowsComponent:"input",selectableRowsComponentProps:{},selectableRowsVisibleOnly:!1,selectableRowsSingle:!1,clearSelectedRows:!1,expandableRows:!1,expandableRowDisabled:null,expandableRowExpanded:null,expandOnRowClicked:!1,expandableRowsHideExpander:!1,expandOnRowDoubleClicked:!1,expandableInheritConditionalStyles:!1,expandableRowsComponent:function(){return r.default.createElement("div",null,"To add an expander pass in a component instance via ",r.default.createElement("strong",null,"expandableRowsComponent"),". You can then access props.data from this component.")},expandableIcon:{collapsed:r.default.createElement((()=>r.default.createElement("svg",{fill:"currentColor",height:"24",viewBox:"0 0 24 24",width:"24",xmlns:"http://www.w3.org/2000/svg"},r.default.createElement("path",{d:"M8.59 16.34l4.58-4.59-4.58-4.59L10 5.75l6 6-6 6z"}),r.default.createElement("path",{d:"M0-.25h24v24H0z",fill:"none"}))),null),expanded:r.default.createElement((()=>r.default.createElement("svg",{fill:"currentColor",height:"24",viewBox:"0 0 24 24",width:"24",xmlns:"http://www.w3.org/2000/svg"},r.default.createElement("path",{d:"M7.41 7.84L12 12.42l4.59-4.58L18 9.25l-6 6-6-6z"}),r.default.createElement("path",{d:"M0-.75h24v24H0z",fill:"none"}))),null)},expandableRowsComponentProps:{},progressPending:!1,progressComponent:r.default.createElement("div",{style:{fontSize:"24px",fontWeight:700,padding:"24px"}},"Loading..."),persistTableHead:!1,sortIcon:null,sortFunction:null,sortServer:!1,striped:!1,highlightOnHover:!1,pointerOnHover:!1,noContextMenu:!1,contextMessage:{singular:"item",plural:"items",message:"selected"},actions:null,contextActions:null,contextComponent:null,defaultSortFieldId:null,defaultSortAsc:!0,responsive:!0,noDataComponent:r.default.createElement("div",{style:{padding:"24px"}},"There are no records to display"),disabled:!1,noTableHead:!1,noHeader:!1,subHeader:!1,subHeaderAlign:exports.Alignment.RIGHT,subHeaderWrap:!0,subHeaderComponent:null,fixedHeader:!1,fixedHeaderScrollHeight:"100vh",pagination:!1,paginationServer:!1,paginationServerOptions:{persistSelectedOnSort:!1,persistSelectedOnPageChange:!1},paginationDefaultPage:1,paginationResetDefaultPage:!1,paginationTotalRows:0,paginationPerPage:10,paginationRowsPerPageOptions:[10,15,20,25,30],paginationComponent:null,paginationComponentOptions:{},paginationIconFirstPage:r.default.createElement((()=>r.default.createElement("svg",{xmlns:"http://www.w3.org/2000/svg",width:"24",height:"24",viewBox:"0 0 24 24","aria-hidden":"true",role:"presentation"},r.default.createElement("path",{d:"M18.41 16.59L13.82 12l4.59-4.59L17 6l-6 6 6 6zM6 6h2v12H6z"}),r.default.createElement("path",{fill:"none",d:"M24 24H0V0h24v24z"}))),null),paginationIconLastPage:r.default.createElement((()=>r.default.createElement("svg",{xmlns:"http://www.w3.org/2000/svg",width:"24",height:"24",viewBox:"0 0 24 24","aria-hidden":"true",role:"presentation"},r.default.createElement("path",{d:"M5.59 7.41L10.18 12l-4.59 4.59L7 18l6-6-6-6zM16 6h2v12h-2z"}),r.default.createElement("path",{fill:"none",d:"M0 0h24v24H0V0z"}))),null),paginationIconNext:r.default.createElement((()=>r.default.createElement("svg",{xmlns:"http://www.w3.org/2000/svg",width:"24",height:"24",viewBox:"0 0 24 24","aria-hidden":"true",role:"presentation"},r.default.createElement("path",{d:"M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z"}),r.default.createElement("path",{d:"M0 0h24v24H0z",fill:"none"}))),null),paginationIconPrevious:r.default.createElement((()=>r.default.createElement("svg",{xmlns:"http://www.w3.org/2000/svg",width:"24",height:"24",viewBox:"0 0 24 24","aria-hidden":"true",role:"presentation"},r.default.createElement("path",{d:"M15.41 7.41L14 6l-6 6 6 6 1.41-1.41L10.83 12z"}),r.default.createElement("path",{d:"M0 0h24v24H0z",fill:"none"}))),null),dense:!1,conditionalRowStyles:[],theme:"default",customStyles:{},direction:exports.Direction.AUTO,onChangePage:b,onChangeRowsPerPage:b,onRowClicked:b,onRowDoubleClicked:b,onRowMouseEnter:b,onRowMouseLeave:b,onRowExpandToggled:b,onSelectedRowsChange:b,onSort:b,onColumnOrderChange:b},Me={rowsPerPageText:"Rows per page:",rangeSeparatorText:"of",noRowsPerPage:!1,selectAllRowsItem:!1,selectAllRowsItemText:"All"},Le=i.default.nav`
	display: flex;
	flex: 1 1 auto;
	justify-content: flex-end;
	align-items: center;
	box-sizing: border-box;
	padding-right: 8px;
	padding-left: 8px;
	width: 100%;
	${({theme:e})=>e.pagination.style};
`,Ae=i.default.button`
	position: relative;
	display: block;
	user-select: none;
	border: none;
	${({theme:e})=>e.pagination.pageButtonsStyle};
	${({isRTL:e})=>e&&"transform: scale(-1, -1)"};
`,ze=i.default.div`
	display: flex;
	align-items: center;
	border-radius: 4px;
	white-space: nowrap;
	${O`
    width: 100%;
    justify-content: space-around;
  `};
`,_e=i.default.span`
	flex-shrink: 1;
	user-select: none;
`,Ne=i.default(_e)`
	margin: 0 24px;
`,We=i.default(_e)`
	margin: 0 4px;
`;var Be=l.memo((function({rowsPerPage:e,rowCount:t,currentPage:n,direction:o=Te.direction,paginationRowsPerPageOptions:a=Te.paginationRowsPerPageOptions,paginationIconLastPage:r=Te.paginationIconLastPage,paginationIconFirstPage:i=Te.paginationIconFirstPage,paginationIconNext:s=Te.paginationIconNext,paginationIconPrevious:d=Te.paginationIconPrevious,paginationComponentOptions:c=Te.paginationComponentOptions,onChangeRowsPerPage:g=Te.onChangeRowsPerPage,onChangePage:u=Te.onChangePage}){const f=(()=>{const e="object"==typeof window;function t(){return{width:e?window.innerWidth:void 0,height:e?window.innerHeight:void 0}}const[n,o]=l.useState(t);return l.useEffect((()=>{if(!e)return()=>null;function n(){o(t())}return window.addEventListener("resize",n),()=>window.removeEventListener("resize",n)}),[]),n})(),b=ue(o),m=f.width&&f.width>599,h=p(t,e),w=n*e,x=w-e+1,C=1===n,v=n===h,y=Object.assign(Object.assign({},Me),c),R=n===h?`${x}-${t} ${y.rangeSeparatorText} ${t}`:`${x}-${w} ${y.rangeSeparatorText} ${t}`,S=l.useCallback((()=>u(n-1)),[n,u]),E=l.useCallback((()=>u(n+1)),[n,u]),O=l.useCallback((()=>u(1)),[u]),k=l.useCallback((()=>u(p(t,e))),[u,t,e]),P=l.useCallback((e=>g(Number(e.target.value),n)),[n,g]),D=a.map((e=>l.createElement("option",{key:e,value:e},e)));y.selectAllRowsItem&&D.push(l.createElement("option",{key:-1,value:t},y.selectAllRowsItemText));const $=l.createElement(Ie,{onChange:P,defaultValue:e,"aria-label":y.rowsPerPageText},D);return l.createElement(Le,{className:"rdt_Pagination"},!y.noRowsPerPage&&m&&l.createElement(l.Fragment,null,l.createElement(We,null,y.rowsPerPageText),$),m&&l.createElement(Ne,null,R),l.createElement(ze,null,l.createElement(Ae,{id:"pagination-first-page",type:"button","aria-label":"First Page","aria-disabled":C,onClick:O,disabled:C,isRTL:b},i),l.createElement(Ae,{id:"pagination-previous-page",type:"button","aria-label":"Previous Page","aria-disabled":C,onClick:S,disabled:C,isRTL:b},d),!y.noRowsPerPage&&!m&&$,l.createElement(Ae,{id:"pagination-next-page",type:"button","aria-label":"Next Page","aria-disabled":v,onClick:E,disabled:v,isRTL:b},s),l.createElement(Ae,{id:"pagination-last-page",type:"button","aria-label":"Last Page","aria-disabled":v,onClick:k,disabled:v,isRTL:b},r)))}));const Ge=(e,t)=>{const n=l.useRef(!0);l.useEffect((()=>{n.current?n.current=!1:e()}),t)};var Ve=function(e){return function(e){return!!e&&"object"==typeof e}(e)&&!function(e){var t=Object.prototype.toString.call(e);return"[object RegExp]"===t||"[object Date]"===t||function(e){return e.$$typeof===Ue}(e)}(e)};var Ue="function"==typeof Symbol&&Symbol.for?Symbol.for("react.element"):60103;function qe(e,t){return!1!==t.clone&&t.isMergeableObject(e)?Qe((n=e,Array.isArray(n)?[]:{}),e,t):e;var n}function Ye(e,t,n){return e.concat(t).map((function(e){return qe(e,n)}))}function Ke(e){return Object.keys(e).concat(function(e){return Object.getOwnPropertySymbols?Object.getOwnPropertySymbols(e).filter((function(t){return e.propertyIsEnumerable(t)})):[]}(e))}function Xe(e,t){try{return t in e}catch(e){return!1}}function Je(e,t,n){var o={};return n.isMergeableObject(e)&&Ke(e).forEach((function(t){o[t]=qe(e[t],n)})),Ke(t).forEach((function(a){(function(e,t){return Xe(e,t)&&!(Object.hasOwnProperty.call(e,t)&&Object.propertyIsEnumerable.call(e,t))})(e,a)||(Xe(e,a)&&n.isMergeableObject(t[a])?o[a]=function(e,t){if(!t.customMerge)return Qe;var n=t.customMerge(e);return"function"==typeof n?n:Qe}(a,n)(e[a],t[a],n):o[a]=qe(t[a],n))})),o}function Qe(e,t,n){(n=n||{}).arrayMerge=n.arrayMerge||Ye,n.isMergeableObject=n.isMergeableObject||Ve,n.cloneUnlessOtherwiseSpecified=qe;var o=Array.isArray(t);return o===Array.isArray(e)?o?n.arrayMerge(e,t,n):Je(e,t,n):qe(t,n)}Qe.all=function(e,t){if(!Array.isArray(e))throw new Error("first argument should be an array");return e.reduce((function(e,n){return Qe(e,n,t)}),{})};var Ze=Qe;const et={text:{primary:"rgba(0, 0, 0, 0.87)",secondary:"rgba(0, 0, 0, 0.54)",disabled:"rgba(0, 0, 0, 0.38)"},background:{default:"#FFFFFF"},context:{background:"#e3f2fd",text:"rgba(0, 0, 0, 0.87)"},divider:{default:"rgba(0,0,0,.12)"},button:{default:"rgba(0,0,0,.54)",focus:"rgba(0,0,0,.12)",hover:"rgba(0,0,0,.12)",disabled:"rgba(0, 0, 0, .18)"},selected:{default:"#e3f2fd",text:"rgba(0, 0, 0, 0.87)"},highlightOnHover:{default:"#EEEEEE",text:"rgba(0, 0, 0, 0.87)"},striped:{default:"#FAFAFA",text:"rgba(0, 0, 0, 0.87)"}},tt={default:et,light:et,dark:{text:{primary:"#FFFFFF",secondary:"rgba(255, 255, 255, 0.7)",disabled:"rgba(0,0,0,.12)"},background:{default:"#424242"},context:{background:"#E91E63",text:"#FFFFFF"},divider:{default:"rgba(81, 81, 81, 1)"},button:{default:"#FFFFFF",focus:"rgba(255, 255, 255, .54)",hover:"rgba(255, 255, 255, .12)",disabled:"rgba(255, 255, 255, .18)"},selected:{default:"rgba(0, 0, 0, .7)",text:"#FFFFFF"},highlightOnHover:{default:"rgba(0, 0, 0, .7)",text:"#FFFFFF"},striped:{default:"rgba(0, 0, 0, .87)",text:"#FFFFFF"}}};function nt(e,t,n,o){const[r,i]=l.useState((()=>u(e))),[s,d]=l.useState(""),[c,g]=l.useState(""),[p,f]=l.useState(null),b=l.useRef("");Ge((()=>{i(u(e))}),[e]);const m=l.useCallback((e=>{var t,n,o;const{attributes:a}=e.target,l=null===(t=a.getNamedItem("data-column-id"))||void 0===t?void 0:t.value;l&&(b.current=(null===(o=null===(n=r[w(r,l)])||void 0===n?void 0:n.id)||void 0===o?void 0:o.toString())||"",d(b.current))}),[r]),h=l.useCallback((e=>{var n;const{attributes:o}=e.target,a=null===(n=o.getNamedItem("data-column-id"))||void 0===n?void 0:n.value;if(a&&b.current&&a!==b.current){const e=w(r,b.current),n=w(r,a),o=[...r];o[e]=r[n],o[n]=r[e],i(o),t(o)}}),[t,r]),x=l.useCallback((e=>{e.preventDefault()}),[]),C=l.useCallback((e=>{e.preventDefault()}),[]),v=l.useCallback((e=>{e.preventDefault(),b.current="",d("")}),[]),y=l.useCallback((e=>{var t,n,o;const a=e.target,{attributes:l}=null==a?void 0:a.parentNode,i=null===(t=l.getNamedItem("data-column-id"))||void 0===t?void 0:t.value;i&&(b.current=(null===(o=null===(n=r[w(r,i)])||void 0===n?void 0:n.id)||void 0===o?void 0:o.toString())||"",g(b.current),f(e.target))}),[r]),R=l.useCallback((e=>{var t,n;if(""===c||null===p)return;const o=w(r,c),a=null==p?void 0:p.parentNode,l=[...r];let s=e.clientX-Math.trunc(a.getBoundingClientRect().left);const d=Number(null===(t=l[o].minWidth)||void 0===t?void 0:t.replace(/\D/g,"")),g=Number(null===(n=l[o].maxWidth)||void 0===n?void 0:n.replace(/\D/g,""));s=d&&s<d?d:g&&s>g?g:Math.max(s,10),l[o].width=`${s}px`,i(l)}),[c,r]),S=l.useCallback((()=>{g("")}),[]),E=function(e=!1){return e?a.ASC:a.DESC}(o),O=l.useMemo((()=>r[w(r,null==n?void 0:n.toString())]||{}),[n,r]);l.useEffect((()=>(""!==c&&(window.addEventListener("pointermove",R),window.addEventListener("pointerup",S)),()=>{window.removeEventListener("pointermove",R),window.removeEventListener("pointerup",S)})),[c]);return{tableColumns:r,draggingColumnId:s,handleDragStart:m,handleDragEnter:h,handleDragOver:x,handleDragLeave:C,handleDragEnd:v,defaultSortDirection:E,defaultSortColumn:O,resizingColumnId:c,handleResizeStart:y,setColumnOffset:(e,t)=>{const n=w(r,t.toString()),o=[...r];o[n].leftOffset=`${e}px`,i(o)}}}var ot=l.memo((function(e){const{data:n=Te.data,columns:o=Te.columns,title:r=Te.title,actions:i=Te.actions,keyField:c=Te.keyField,striped:g=Te.striped,highlightOnHover:u=Te.highlightOnHover,pointerOnHover:b=Te.pointerOnHover,dense:m=Te.dense,selectableRows:w=Te.selectableRows,selectableRowsSingle:x=Te.selectableRowsSingle,selectableRowsHighlight:v=Te.selectableRowsHighlight,selectableRowsNoSelectAll:R=Te.selectableRowsNoSelectAll,selectableRowsVisibleOnly:O=Te.selectableRowsVisibleOnly,selectableRowSelected:k=Te.selectableRowSelected,selectableRowDisabled:P=Te.selectableRowDisabled,selectableRowsComponent:D=Te.selectableRowsComponent,selectableRowsComponentProps:$=Te.selectableRowsComponentProps,onRowExpandToggled:H=Te.onRowExpandToggled,onSelectedRowsChange:j=Te.onSelectedRowsChange,expandableIcon:F=Te.expandableIcon,onChangeRowsPerPage:T=Te.onChangeRowsPerPage,onChangePage:M=Te.onChangePage,paginationServer:L=Te.paginationServer,paginationServerOptions:A=Te.paginationServerOptions,paginationTotalRows:z=Te.paginationTotalRows,paginationDefaultPage:_=Te.paginationDefaultPage,paginationResetDefaultPage:N=Te.paginationResetDefaultPage,paginationPerPage:W=Te.paginationPerPage,paginationRowsPerPageOptions:B=Te.paginationRowsPerPageOptions,paginationIconLastPage:G=Te.paginationIconLastPage,paginationIconFirstPage:V=Te.paginationIconFirstPage,paginationIconNext:U=Te.paginationIconNext,paginationIconPrevious:q=Te.paginationIconPrevious,paginationComponent:Y=Te.paginationComponent,paginationComponentOptions:K=Te.paginationComponentOptions,responsive:X=Te.responsive,progressPending:J=Te.progressPending,progressComponent:Q=Te.progressComponent,persistTableHead:Z=Te.persistTableHead,noDataComponent:ee=Te.noDataComponent,disabled:ne=Te.disabled,noTableHead:oe=Te.noTableHead,noHeader:ae=Te.noHeader,fixedHeader:le=Te.fixedHeader,fixedHeaderScrollHeight:re=Te.fixedHeaderScrollHeight,pagination:ie=Te.pagination,subHeader:se=Te.subHeader,subHeaderAlign:ce=Te.subHeaderAlign,subHeaderWrap:ue=Te.subHeaderWrap,subHeaderComponent:pe=Te.subHeaderComponent,noContextMenu:fe=Te.noContextMenu,contextMessage:be=Te.contextMessage,contextActions:me=Te.contextActions,contextComponent:he=Te.contextComponent,expandableRows:we=Te.expandableRows,onRowClicked:xe=Te.onRowClicked,onRowDoubleClicked:ve=Te.onRowDoubleClicked,onRowMouseEnter:ye=Te.onRowMouseEnter,onRowMouseLeave:Re=Te.onRowMouseLeave,sortIcon:He=Te.sortIcon,onSort:je=Te.onSort,sortFunction:Fe=Te.sortFunction,sortServer:Ie=Te.sortServer,expandableRowsComponent:Me=Te.expandableRowsComponent,expandableRowsComponentProps:Le=Te.expandableRowsComponentProps,expandableRowDisabled:Ae=Te.expandableRowDisabled,expandableRowsHideExpander:ze=Te.expandableRowsHideExpander,expandOnRowClicked:_e=Te.expandOnRowClicked,expandOnRowDoubleClicked:Ne=Te.expandOnRowDoubleClicked,expandableRowExpanded:We=Te.expandableRowExpanded,expandableInheritConditionalStyles:Ve=Te.expandableInheritConditionalStyles,defaultSortFieldId:Ue=Te.defaultSortFieldId,defaultSortAsc:qe=Te.defaultSortAsc,clearSelectedRows:Ye=Te.clearSelectedRows,conditionalRowStyles:Ke=Te.conditionalRowStyles,theme:Xe=Te.theme,customStyles:Je=Te.customStyles,direction:Qe=Te.direction,onColumnOrderChange:et=Te.onColumnOrderChange,className:ot}=e,{tableColumns:at,draggingColumnId:lt,handleDragStart:rt,handleDragEnter:it,handleDragOver:st,handleDragLeave:dt,handleDragEnd:ct,defaultSortDirection:gt,defaultSortColumn:ut,resizingColumnId:pt,handleResizeStart:ft,setColumnOffset:bt}=nt(o,et,Ue,qe),[{rowsPerPage:mt,currentPage:ht,selectedRows:wt,allSelected:xt,selectedCount:Ct,selectedColumn:vt,sortDirection:yt,toggleOnSelectedRowsChange:Rt},St]=l.useReducer(C,{allSelected:!1,selectedCount:0,selectedRows:[],selectedColumn:ut,toggleOnSelectedRowsChange:!1,sortDirection:gt,currentPage:_,rowsPerPage:W,selectedRowsFlag:!1,contextMessage:Te.contextMessage}),{persistSelectedOnSort:Et=!1,persistSelectedOnPageChange:Ot=!1}=A,kt=!(!L||!Ot&&!Et),Pt=ie&&!J&&n.length>0,Dt=Y||Be,$t=l.useMemo((()=>((e={},t="default",n="default")=>{const o=tt[t]?t:n;return Ze({table:{style:{color:(a=tt[o]).text.primary,backgroundColor:a.background.default}},tableWrapper:{style:{display:"table"}},responsiveWrapper:{style:{}},header:{style:{fontSize:"22px",color:a.text.primary,backgroundColor:a.background.default,minHeight:"56px",paddingLeft:"16px",paddingRight:"8px"}},subHeader:{style:{backgroundColor:a.background.default,minHeight:"52px"}},head:{style:{color:a.text.primary,fontSize:"12px",fontWeight:500}},headRow:{style:{backgroundColor:a.background.default,minHeight:"52px",borderBottomWidth:"1px",borderBottomColor:a.divider.default,borderBottomStyle:"solid"},denseStyle:{minHeight:"32px"}},headCells:{style:{paddingLeft:"16px",paddingRight:"16px"},draggingStyle:{cursor:"move"}},contextMenu:{style:{backgroundColor:a.context.background,fontSize:"18px",fontWeight:400,color:a.context.text,paddingLeft:"16px",paddingRight:"8px",transform:"translate3d(0, -100%, 0)",transitionDuration:"125ms",transitionTimingFunction:"cubic-bezier(0, 0, 0.2, 1)",willChange:"transform"},activeStyle:{transform:"translate3d(0, 0, 0)"}},cells:{style:{paddingLeft:"16px",paddingRight:"16px",wordBreak:"break-word"},draggingStyle:{}},rows:{style:{fontSize:"13px",fontWeight:400,color:a.text.primary,backgroundColor:a.background.default,minHeight:"48px","&:not(:last-of-type)":{borderBottomStyle:"solid",borderBottomWidth:"1px",borderBottomColor:a.divider.default}},denseStyle:{minHeight:"32px"},selectedHighlightStyle:{"&:nth-of-type(n)":{color:a.selected.text,backgroundColor:a.selected.default,borderBottomColor:a.background.default}},highlightOnHoverStyle:{color:a.highlightOnHover.text,backgroundColor:a.highlightOnHover.default,transitionDuration:"0.15s",transitionProperty:"background-color",borderBottomColor:a.background.default,outlineStyle:"solid",outlineWidth:"1px",outlineColor:a.background.default},stripedStyle:{color:a.striped.text,backgroundColor:a.striped.default}},expanderRow:{style:{color:a.text.primary,backgroundColor:a.background.default}},expanderCell:{style:{flex:"0 0 48px"}},expanderButton:{style:{color:a.button.default,fill:a.button.default,backgroundColor:"transparent",borderRadius:"2px",transition:"0.25s",height:"100%",width:"100%","&:hover:enabled":{cursor:"pointer"},"&:disabled":{color:a.button.disabled},"&:hover:not(:disabled)":{cursor:"pointer",backgroundColor:a.button.hover},"&:focus":{outline:"none",backgroundColor:a.button.focus},svg:{margin:"auto"}}},pagination:{style:{color:a.text.secondary,fontSize:"13px",minHeight:"56px",backgroundColor:a.background.default,borderTopStyle:"solid",borderTopWidth:"1px",borderTopColor:a.divider.default},pageButtonsStyle:{borderRadius:"50%",height:"40px",width:"40px",padding:"8px",margin:"px",cursor:"pointer",transition:"0.4s",color:a.button.default,fill:a.button.default,backgroundColor:"transparent","&:disabled":{cursor:"unset",color:a.button.disabled,fill:a.button.disabled},"&:hover:not(:disabled)":{backgroundColor:a.button.hover},"&:focus":{outline:"none",backgroundColor:a.button.focus}}},noData:{style:{display:"flex",alignItems:"center",justifyContent:"center",color:a.text.primary,backgroundColor:a.background.default}},progress:{style:{display:"flex",alignItems:"center",justifyContent:"center",color:a.text.primary,backgroundColor:a.background.default}}},e);var a})(Je,Xe)),[Je,Xe]),Ht=l.useMemo((()=>Object.assign({},"auto"!==Qe&&{dir:Qe})),[Qe]),jt=l.useMemo((()=>{if(Ie)return n;if((null==vt?void 0:vt.sortFunction)&&"function"==typeof vt.sortFunction){const e=vt.sortFunction,t=yt===a.ASC?e:(t,n)=>-1*e(t,n);return[...n].sort(t)}return function(e,t,n,o){return t?o&&"function"==typeof o?o(e.slice(0),t,n):e.slice(0).sort(((e,o)=>{let a,l;if("string"==typeof t?(a=d(e,t),l=d(o,t)):(a=t(e),l=t(o)),"asc"===n){if(a<l)return-1;if(a>l)return 1}if("desc"===n){if(a>l)return-1;if(a<l)return 1}return 0})):e}(n,null==vt?void 0:vt.selector,yt,Fe)}),[Ie,vt,yt,n,Fe]),Ft=l.useMemo((()=>{if(ie&&!L){const e=ht*mt,t=e-mt;return jt.slice(t,e)}return jt}),[ht,ie,L,mt,jt]),It=l.useCallback((e=>{St(e)}),[]),Tt=l.useCallback((e=>{St(e)}),[]),Mt=l.useCallback((e=>{St(e)}),[]),Lt=l.useCallback(((e,t)=>xe(e,t)),[xe]),At=l.useCallback(((e,t)=>ve(e,t)),[ve]),zt=l.useCallback(((e,t)=>ye(e,t)),[ye]),_t=l.useCallback(((e,t)=>Re(e,t)),[Re]),Nt=l.useCallback((e=>St({type:"CHANGE_PAGE",page:e,paginationServer:L,visibleOnly:O,persistSelectedOnPageChange:Ot})),[L,Ot,O]),Wt=l.useCallback((e=>{const t=p(z||Ft.length,e),n=f(ht,t);L||Nt(n),St({type:"CHANGE_ROWS_PER_PAGE",page:n,rowsPerPage:e})}),[ht,Nt,L,z,Ft.length]);if(ie&&!L&&jt.length>0&&0===Ft.length){const e=p(jt.length,mt),t=f(ht,e);Nt(t)}Ge((()=>{j({allSelected:xt,selectedCount:Ct,selectedRows:wt.slice(0)})}),[Rt]),Ge((()=>{je(vt,yt,jt.slice(0))}),[vt,yt]),Ge((()=>{M(ht,z||jt.length)}),[ht]),Ge((()=>{T(mt,ht)}),[mt]),Ge((()=>{Nt(_)}),[_,N]),Ge((()=>{if(ie&&L&&z>0){const e=p(z,mt),t=f(ht,e);ht!==t&&Nt(t)}}),[z]),l.useEffect((()=>{St({type:"CLEAR_SELECTED_ROWS",selectedRowsFlag:Ye})}),[x,Ye]),l.useEffect((()=>{if(!k)return;const e=jt.filter((e=>k(e))),t=x?e.slice(0,1):e;St({type:"SELECT_MULTIPLE_ROWS",keyField:c,selectedRows:t,totalRows:jt.length,mergeSelections:kt})}),[n,k]);const Bt=O?Ft:jt,Gt=Ot||x||R;return l.createElement(t.ThemeProvider,{theme:$t},!ae&&(!!r||!!i)&&l.createElement(Ce,{title:r,actions:i,showMenu:!fe,selectedCount:Ct,direction:Qe,contextActions:me,contextComponent:he,contextMessage:be}),se&&l.createElement(Se,{align:ce,wrapContent:ue},pe),l.createElement(Oe,Object.assign({responsive:X,fixedHeader:le,fixedHeaderScrollHeight:re,className:ot},Ht),l.createElement(Pe,null,J&&!Z&&l.createElement(ke,null,Q),l.createElement(y,{disabled:ne,className:"rdt_Table",role:"table"},!oe&&(!!Z||jt.length>0&&!J)&&l.createElement(S,{className:"rdt_TableHead",role:"rowgroup",fixedHeader:le},l.createElement(E,{className:"rdt_TableHeadRow",role:"row",dense:m},w&&(Gt?l.createElement(I,{style:{flex:"0 0 48px"}}):l.createElement(ge,{allSelected:xt,selectedRows:wt,selectableRowsComponent:D,selectableRowsComponentProps:$,selectableRowDisabled:P,rowData:Bt,keyField:c,mergeSelections:kt,onSelectAllRows:Tt})),we&&!ze&&l.createElement(De,null),at.map((e=>l.createElement(de,{key:e.id,column:e,selectedColumn:vt,disabled:J||0===jt.length,pagination:ie,paginationServer:L,persistSelectedOnSort:Et,selectableRowsVisibleOnly:O,sortDirection:yt,sortIcon:He,sortServer:Ie,onSort:It,onDragStart:rt,onDragOver:st,onDragEnd:ct,onDragEnter:it,onDragLeave:dt,draggingColumnId:lt,handleResizeStart:ft,resizingColumnId:pt,setColumnOffset:bt}))))),!jt.length&&!J&&l.createElement($e,null,ee),J&&Z&&l.createElement(ke,null,Q),!J&&jt.length>0&&l.createElement(Ee,{className:"rdt_TableBody",role:"rowgroup"},Ft.map(((e,t)=>{const n=s(e,c),o=function(e=""){return"number"!=typeof e&&(!e||0===e.length)}(n)?t:n,a=h(e,wt,c),r=!!(we&&We&&We(e)),i=!!(we&&Ae&&Ae(e));return l.createElement(te,{id:o,key:o,keyField:c,"data-row-id":o,columns:at,row:e,rowCount:jt.length,rowIndex:t,selectableRows:w,expandableRows:we,expandableIcon:F,highlightOnHover:u,pointerOnHover:b,dense:m,expandOnRowClicked:_e,expandOnRowDoubleClicked:Ne,expandableRowsComponent:Me,expandableRowsComponentProps:Le,expandableRowsHideExpander:ze,defaultExpanderDisabled:i,defaultExpanded:r,expandableInheritConditionalStyles:Ve,conditionalRowStyles:Ke,selected:a,selectableRowsHighlight:v,selectableRowsComponent:D,selectableRowsComponentProps:$,selectableRowDisabled:P,selectableRowsSingle:x,striped:g,onRowExpandToggled:H,onRowClicked:Lt,onRowDoubleClicked:At,onRowMouseEnter:zt,onRowMouseLeave:_t,onSelectedRow:Mt,draggingColumnId:lt,onDragStart:rt,onDragOver:st,onDragEnd:ct,onDragEnter:it,onDragLeave:dt})})))))),Pt&&l.createElement("div",null,l.createElement(Dt,{onChangePage:Nt,onChangeRowsPerPage:Wt,rowCount:z||jt.length,currentPage:ht,rowsPerPage:mt,direction:Qe,paginationRowsPerPageOptions:B,paginationIconLastPage:G,paginationIconFirstPage:V,paginationIconNext:U,paginationIconPrevious:q,paginationComponentOptions:K})))}));exports.STOP_PROP_TAG="allowRowEvents",exports.createTheme=function(e="default",t,n="default"){return tt[e]||(tt[e]=Ze(tt[n],t||{})),tt[e]=Ze(tt[e],t||{}),tt[e]},exports.default=ot,exports.defaultThemes=tt;
//# sourceMappingURL=index.cjs.js.map
